/*
 * linux/arch/arm/drivers/sound/mkbeep.c
 *
 * Copyright (C) 1994, 1995, 1996 Russell King
 */

#include <linux/errno.h>
#include <linux/fs.h>
#include <linux/fcntl.h>
#include <linux/sched.h>
#include "soundinit.h"
#include "soundirq.h"
#include "voice.h"

/* Make a beep of frequency 'freq' HZ and 'duration' cs */

int mk_beep(int freq, int vol, int duration)
{
	int voice;
	struct voice_driver *driver;

	if (duration == 0)
		return 0;

	if (sound_voice[0] != &sound_quiet_voice)
		return 0;

	if ((voice = voice_allocate(VOICE_WAVE, 0)) < 0)
		return voice;

	driver = (struct voice_driver *)voice;

	driver->vd_dur    = duration * 20833 / 100;
	driver->vd_phase  = freq;
	driver->vd_volume = vol;

	voice_install (driver, 0);
	return 0;
}
