/*
 * linux/arch/arm/drivers/sound/sndvars.S
 *
 * Copyright (C) 1994, 1995, 1996 Russell King
 *
 * Absolute variable locations in the sound system
 *
 * Map is:
 *   0x0800		=	sound buffer address
 *   0x0804		=	sound system update flags
 *   0x0808		=	log of number of channels available
 *   0x080C		=	sample length
 *   0x0810		=	Vidc sample period
 *   0x0814		=	Stereo Image registers
 *   0x0834		=	Voice registers
 *   0x0854		=	Volume
 *   0x1000 - 0x1FFF	=	sound buffer 0
 *   0x2000 - 0x2FFF	=	sound buffer 1
 *   0x4100		=	Signed linear conversion table
 *   0x4200		=	Logarithmic conversion table
 */

#define N_CHANNELS	8

			.global	_sound_datastart
			.global	_sound_buffer
			.global	_sound_lognchannels
			.global	_sound_samplelength
			.global	_sound_vidcsampleperiod
			.global	_sound_toupdate
			.global	_sound_stereoimage
			.global	_sound_voice
			.global	_sound_buffer0
			.global	_sound_buffer1
			.global	_sound_volume
			.global	_table_linsigned
			.global	_table_log

			.org	0
Ls:	
			.org	0x800
.equ _sound_datastart, . - Ls
.equ _sound_buffer, . - Ls
			.space	4		@3
.equ _sound_toupdate, . - Ls
			.space	4		@4
.equ _sound_lognchannels, . - Ls
			.space	4		@5
.equ _sound_samplelength, . - Ls
			.space	4		@6
.equ _sound_vidcsampleperiod, . - Ls
			.space	4	@7
.equ _sound_stereoimage, . - Ls
			.space	4*N_CHANNELS
.equ _sound_voice, . - Ls
			.space	4*N_CHANNELS
.equ _sound_volume, . - Ls
			.space	4

.equ _sound_buffer0, 0x1000
.equ _sound_buffer1, 0x2000

.equ _table_linsigned, 0x4100
.equ _table_log, 0x4200
