/*
 * soundcont.h
 *
 * Control various sound parameters
 *
 */

#ifndef __sound_soundcont_h
#define __sound_soundcont_h

/*
 * Two tables used in voice generators.
 * These are scaled according to the current overall volume setting
 */

extern unsigned char table_linsigned[];
extern unsigned char table_log[];
extern unsigned char sound_allocated[];

/*
 * Change the sample period of the system and number of active channels.
 */
extern int sound_configure(int period, int channels, int *operiod, int *ochannels);

/*
 * Set the overall volume of the system.
 */
extern int sound_vol(int volume);

/* 
 * Set the stereo location of this channel
 */
extern int sound_setimage(int channel, int image);

/*
 * Increment the sound usage counter and enable sound irqs
 */
extern void soundirq_inc(void);
#endif
