/*
 * linux/arch/arm/drivers/sound/soundirq.s
 *
 * Copyright (C) 1994, 1995, 1996 Russell King
 *
 * Sound interrupt handling
 */

		.text

		.global	_sound_irq

#define vidc	0x03400000
#define memc	0x03600000

LCsound_datastart:
		.word	_sound_datastart
LCsoundirq_use:
		.word	_soundirq_use
LCmemc_ctrl_reg:
		.word	_memc_ctrl_reg

_sound_irq:	stmfd	sp!, {r4-r12,lr}
		ldr	r12, [pc, #LCsound_datastart - . - 8]
		mov	r9, #vidc
		ldmia	r12, {r3-r7}
		tst	r4, #1			@ Update sound period?
		andne	r7, r7, #0x000000ff
		orrne	r7, r7, #0x00000100
		orrne	r7, r7, #0xC0000000
		strne	r7, [r9]
		tst	r4, #2			@ Update image registers?
		beq	_noupdate_image
		add	r0, r12, #20+8*4
		mov	r2, #0x80000000
LC00:		sub	r2, r2, #0x04000000
		ldr	r1, [r0, #-4]!
		and	r1, r1, #0xff
		orr	r1, r2, r1, lsr #5
		bic	r1, r1, #0x83000000
		str	r1, [r9]
		tst	r2, #0x1C000000
		bne	LC00
_noupdate_image:
		BIC	r4,r4,#3
		EORS	r3,r3,#1
		STMIA	r12,{r3,r4}
		MOVEQ	r0,#0x1000		@ Buffer start
		MOVNE	r0,#0x2000
		ADD	r1,r0,r6, lsl  r5		@ Buffer end
		MOV	r2,#1
		MOV	r2,r2, lsl  r5
		STMFD	sp!,{r0-r2,r12}
		TEQ	r5,#2
		BEQ	_chan_4
		TEQ	r5,#1
		BEQ	_chan_2
		TEQ	r5,#0
		BEQ	_chan_1
		ADD	r0,r0,#7
		ADD	r1,r1,#7
		ADD	r12,r12,#80
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call eighth voice generator
		LDMIA	sp,{r0-r2,r12}
		ADD	r0,r0,#6
		ADD	r1,r1,#6
		ADD	r12,r12,#76
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call seventh voice generator
		LDMIA	sp,{r0-r2,r12}
		ADD	r0,r0,#5
		ADD	r1,r1,#5
		ADD	r12,r12,#72
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call sixth generator
		LDMIA	sp,{r0-r2,r12}
		ADD	r0,r0,#4
		ADD	r1,r1,#4
		ADD	r12,r12,#68
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call fifth generator
		LDMIA	sp,{r0-r2,r12}
_chan_4:	ADD	r0,r0,#3
		ADD	r1,r1,#3
		ADD	r12,r12,#64
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call fourth generator
		LDMIA	sp,{r0-r2,r12}
		ADD	r0,r0,#2
		ADD	r1,r1,#2
		ADD	r12,r12,#60
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call third generator
		LDMIA	sp,{r0-r2,r12}
_chan_2:	ADD	r0,r0,#1
		ADD	r1,r1,#1
		ADD	r12,r12,#56
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call second generator
		LDMIA	sp,{r0-r2,r12}
_chan_1:	ADD	r12,r12,#52
		LDR	r3,[r12]
		MOV	lr,pc
		LDR	pc,[r3]			@ Call first generator
		LDMIA	sp!,{r0-r2,r12}
		mov	r3, #memc | 0x00080000
		orr	r3, r3, #0x0001e000
		sub	r1, r1, #16
		orr	r2, r3, r1, lsr #2
		orr	r2, r2, #0x00020000
		strb	r2, [r2]		@ Set up SendN
		orr	r2, r3, r0, lsr #2
		strb	r2, [r2]		@ Set up Sstart
		ldr	r4, [pc, #LCsoundirq_use - . - 8]
		ldr	r4, [r4]
		teq	r4, #0
		ldmnefd	sp!, {r4-r12,pc}^
		ldr	r0, [pc, #LCmemc_ctrl_reg - . - 8]
		LDR	r1, [r0]
		bic	r1, r1, #0xFF000000
		bic	r1, r1, #0x00FF0000
		bic	r1, r1, #0x0000E000 | 1<<11
		str	r1, [r0]
		orr	r1, r1, #memc
		orr	r1, r1, #0x000E0000
		str	r1, [r1]
		ldmfd	sp!, {r4-r12,pc}^

		.global	_soundirq_dec
_soundirq_dec:	ldr	r0, [pc, #LCsoundirq_use - . - 8]
		ldr	r1, [r0]
		subs	r1, r1, #1
		movmi	r1, #0
		str	r1, [r0]
		movs	pc, lr

		.global	_soundirq_inc
_soundirq_inc:	stmfd	sp!, {lr}
		ldr	r0, [pc, #LCsoundirq_use - . - 8]
		ldr	r1, [r0]
		add	r1, r1, #1
		str	r1, [r0]
		teq	r1, #1
		movnes	pc, lr
		bl	_sound_irq		@ causes first fill & sets up
		mov	r1, #memc | 0x000C0000
		str	r1, [r1]			@ force swap
		ldr	r0, [pc, #LCmemc_ctrl_reg - . - 8]
		ldr	r1, [r0]
		bic	r1, r1, #0xFF000000
		bic	r1, r1, #0x00FF0000
		bic	r1, r1, #0x0000E000
		orr	r1, r1, #1<<11
		str	r1, [r0]
		orr	r1, r1, #memc
		orr	r1, r1, #0x000E0000
		str	r1, [r1]
		ldmfd	sp!, {pc}^

		.global	_sound_quiet_voice
_sound_quiet_voice:
		.word	_sound_quiet
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0

		.global	_sound_quiet
_sound_quiet:	MOV	r3,#0
LC01:		STRB	r3,[r0],r2
		EOR	r3,r3,#1
		CMP	r0,r1
		BLT	LC01
		MOVS	pc,lr

		.global	_sound_to_quiet_voice
_sound_to_quiet_voice:
		.word	_sound_to_quiet
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0

_sound_to_quiet:
		ADR	r4,_sound_to_quiet_voice2
		STR	r4,[r12]
		MOV	r3,#0
LC02:		STRB	r3,[r0],r2
		EOR	r3,r3,#1
		CMP	r0,r1
		BLT	LC02
		MOVS	pc,lr

_sound_to_quiet_voice2:
		.word	_sound_to_quiet2
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0
		.word	0

_sound_to_quiet2:
		ADR	r4,_sound_quiet_voice
		STR	r4,[r12]
		MOV	r3,#0
LC03:		STRB	r3,[r0],r2
		EOR	r3,r3,#1
		CMP	r0,r1
		BLT	LC03
		B	_soundirq_dec

		.data

_soundirq_use:	.word	0

