/*
 * linux/arch/arm/lib/backtrace.S
 *
 * Copyright (C) 1995, 1996 Russell King
 */

#include <asm/assembler.h>
		.text

@ fp is 0 or stack frame

		.global	_c_backtrace
_c_backtrace:	stmfd	sp!, {r4 - r9, lr}	@ Save an extra register so we have a location...
		tst	r1, #0x10		@ 26 or 32-bit?
		moveq	r9, #0xfc000003
		movne	r9, #0
		tst	r0, r9
		movne	r0, #0
		movs	r4, r0
Lbadbacktrace:	moveq	r0, #-2
		LOADREGS(eqfd, sp!, {r4 - r9, pc})
Lloop:		tst	r4, r9			@ Check for address exceptions...
		bne	Lbadbacktrace
		ldmda	r4, {r5, r6, r7, r8}	@ fp, sp, lr, pc
		sub	r8, r8, #16		@ Correct PC for prefetching
		bic	r8, r8, r9
		adr	r0, Lfe
		mov	r1, r8
		bic	r2, r7, r9
		mov	r3, r6
		stmfd	sp!, {r5}
		bl	_printk
		add	sp, sp, #4
		ldr	r3, [r8, #4]
		mov	r1, r3, lsr #10
		ldr	r0, Ldsi+4
		teq	r1, r0			@ Check for stmia sp!, {args}
		bne	Lnotdatasaveargs
		mov	r6, #9
		sub	r7, r4, #16
		mov	r8, #1
1:		tst	r3, r8, lsl r6
		beq	2f
		mov	r1, r6
		ldr	r2, [r7], #-4
		adr	r0, Lfp
		bl	_printk
2:		subs	r6, r6, #1
		bpl	1b
		add	r8, r8, #4		@ 
Lnotdatasaveargs:
		ldr	r3, [r8, #4]		@ Get 'stmia sp!, {rlist, fp, ip, lr, pc}' instruction
		mov	r2, r3, lsr #10
		ldr	r1, Ldsi
		teq	r2, r1
		bne	Lnot_datasave
		mov	r6, #9
		sub	r7, r4, #16		@ Now points to highest saved register
		mov	r8, #1
3:		tst	r3, r8, lsl r6		@ Test bit 'r6'
		beq	4f
		mov	r1, r6
		ldr	r2, [r7], #-4		@ Get reg
		adr	r0, Lfp
		bl	_printk
4:		subs	r6, r6, #1
		bpl	3b

Lnot_datasave:	teq	r4, r5
		movne	r4, r5
		teqne	r4, #0
		bne	Lloop
		LOADREGS(fd, sp!, {r4 - r9, pc})

Lfe:		.ascii	"Function entered at 0x%p [lr = %p sp = %p fp = %p]\n"
		.byte 0
Lfp:		.ascii	"  r%d = %p\n"
		.byte 0
		.align
Ldsi:		.word	0x00e92dd8 >> 2
		.word	0x00e92d00 >> 2
