/*
 * linux/arch/arm/lib/calls.h
 *
 * Copyright (C) 1995, 1996 Russell King
 */
#ifndef NR_SYSCALLS
#define NR_syscalls 256
#define NR_SYSCALLS 163
#else

/* 0 */		.long	_sys_setup
		.long	_sys_exit
		.long	_sys_fork
		.long	_sys_read
		.long	_sys_write
/* 5 */		.long	_sys_open
		.long	_sys_close
		.long	_sys_waitpid
		.long	_sys_creat
		.long	_sys_link
/* 10 */	.long	_sys_unlink
		.long	_sys_execve
		.long	_sys_chdir
		.long	_sys_time
		.long	_sys_mknod
/* 15 */	.long	_sys_chmod
		.long	_sys_chown
		.long	_sys_break
		.long	_sys_stat
		.long	_sys_lseek
/* 20 */	.long	_sys_getpid
		.long	_sys_old_arm_mount			/* *** 5 *** */
		.long	_sys_umount
		.long	_sys_setuid
		.long	_sys_getuid
/* 25 */	.long	_sys_stime
		.long	_sys_ptrace
		.long	_sys_alarm
		.long	_sys_fstat
		.long	_sys_pause
/* 30 */	.long	_sys_utime
		.long	_sys_stty
		.long	_sys_gtty
		.long	_sys_access
		.long	_sys_nice
/* 35 */	.long	_sys_ftime
		.long	_sys_sync
		.long	_sys_kill
		.long	_sys_rename
		.long	_sys_mkdir
/* 40 */	.long	_sys_rmdir
		.long	_sys_dup
		.long	_sys_pipe
		.long	_sys_times
		.long	_sys_prof
/* 45 */	.long	_sys_brk
		.long	_sys_setgid
		.long	_sys_getgid
		.long	_sys_signal
		.long	_sys_geteuid
/* 50 */	.long	_sys_getegid
		.long	_sys_acct
		.long	_sys_phys
		.long	_sys_lock
		.long	_sys_ioctl
/* 55 */	.long	_sys_fcntl
		.long	_sys_mpx
		.long	_sys_setpgid
		.long	_sys_ulimit
		.long	_sys_olduname
/* 60 */	.long	_sys_umask
		.long	_sys_chroot
		.long	_sys_ustat
		.long	_sys_dup2
		.long	_sys_getppid
/* 65 */	.long	_sys_getpgrp
		.long	_sys_setsid
		.long	_sys_sigaction
		.long	_sys_sgetmask
		.long	_sys_ssetmask
/* 70 */	.long	_sys_setreuid
		.long	_sys_setregid
		.long	_sys_sigsuspend
		.long	_sys_sigpending
		.long	_sys_sethostname
/* 75 */	.long	_sys_setrlimit
		.long	_sys_getrlimit
		.long	_sys_getrusage
		.long	_sys_gettimeofday
		.long	_sys_settimeofday
/* 80 */	.long	_sys_getgroups
		.long	_sys_setgroups
		.long	_old_select
		.long	_sys_symlink
		.long	_sys_lstat
/* 85 */	.long	_sys_readlink
		.long	_sys_uselib
		.long	_sys_swapon
		.long	_sys_reboot
		.long	_old_readdir
/* 90 */	.long	_old_mmap
		.long	_sys_munmap
		.long	_sys_truncate
		.long	_sys_ftruncate
		.long	_sys_fchmod
/* 95 */	.long	_sys_fchown
		.long	_sys_getpriority
		.long	_sys_setpriority
		.long	_sys_profil
		.long	_sys_statfs
/* 100 */	.long	_sys_fstatfs
		.long	_sys_ni_syscall			/* .long	_sys_ioperm */
		.long	_sys_socketcall
		.long	_sys_syslog
		.long	_sys_setitimer
/* 105 */	.long	_sys_getitimer
		.long	_sys_newstat
		.long	_sys_newlstat
		.long	_sys_newfstat
		.long	_sys_uname
/* 110 */	.long	_sys_iopl
		.long	_sys_vhangup
		.long	_sys_idle
		.long	_sys_syscall			/* call a syscall */
		.long	_sys_wait4
/* 115 */	.long	_sys_swapoff
		.long	_sys_sysinfo
		.long	_sys_ipc
		.long	_sys_fsync
		.long	_sys_sigreturn
		.long	_sys_clone
		.long	_sys_setdomainname
		.long	_sys_newuname
		.long	_sys_ni_syscall			/* .long	_sys_modify_ldt */
		.long	_sys_adjtimex
/* 125 */	.long	_sys_mprotect
		.long	_sys_sigprocmask
		.long	_sys_create_module
		.long	_sys_old_arm_init_module	/* *** 5 *** */
		.long	_sys_delete_module
/* 130 */	.long	_sys_get_kernel_syms
		.long	_sys_ni_syscall			/* .long	_sys_quotactl */
		.long	_sys_getpgid
		.long	_sys_fchdir
		.long	_sys_bdflush
/* 135 */	.long	_sys_sysfs
		.long	_sys_personality
		.long	_sys_ni_syscall			/* .long	_sys_afs_syscall */
		.long	_sys_setfsuid
		.long	_sys_setfsgid
/* 140 */	.long	_sys_old_arm_llseek		/* *** 5 *** */
		.long	_sys_getdents
		.long	_sys_select
		.long	_sys_flock
		.long	_sys_msync
/* 145 */	.long	_sys_readv
		.long	_sys_writev
		.long	_sys_getsid
		.long	_sys_ni_syscall
		.long	_sys_ni_syscall
/* 150 */	.long	_sys_mlock
		.long	_sys_munlock
		.long	_sys_mlockall
		.long	_sys_munlockall
		.long	_sys_sched_setparam
/* 155 */	.long	_sys_sched_getparam
		.long	_sys_sched_setscheduler
		.long	_sys_sched_getscheduler
		.long	_sys_sched_yield
		.long	_sys_sched_get_priority_max
/* 160 */	.long	_sys_sched_get_priority_min
		.long	_sys_sched_rr_get_interval
		.long	_sys_nanosleep
		.long	_sys_mremap
		.space	(NR_syscalls - 163) * 4
#endif
