/*
 * linux/include/asm-arm/arch-a5k/time.h
 *
 * Copyright (c) 1996 Russell King.
 *
 * No real time clock on the evalulation board!
 *
 * Changelog:
 *  24-09-1996	RMK	Created
 */

#define MCLK_47_8

#define TIMER_LOAD                  ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_LOAD))
#define TIMER_VALUE                 ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_VALUE))
#define TIMER_CONTROL               ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_CONTROL))
#define TIMER_CLEAR                 ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_CLEAR))

extern __inline__ unsigned long gettimeoffset (void)
{
	return 0;
}

extern __inline__ int reset_timer (void)
{
  
        *TIMER_LOAD = mSEC_1 ;
	return 1;
}

extern __inline__ unsigned long setup_timer (void)
{
        unsigned int mode ; 

        *TIMER_CLEAR = 1 ;
	*TIMER_LOAD = mSEC_1 ;
	mode = *TIMER_CONTROL ;
	mode |= TIMER_CONTROL_ENABLE | 0xcc ;
	*TIMER_CONTROL = mode ;

	/*
	 * Default the date to 1 Jan 1970 0:0:0
	 * You will have to run a time daemon to set the
	 * clock correctly at bootup
	 */
	return mktime(1970, 1, 1, 0, 0, 0);
}
