/*
 * linux/include/asm-arm/atomic.h
 *
 * Copyright (c) 1996 Russell King.
 *
 * Changelog:
 *  27-06-1996	RMK	Created
 */
#ifndef __ASM_ARM_ATOMIC_H
#define __ASM_ARM_ATOMIC_H

typedef int atomic_t;

extern __inline__ void atomic_add(atomic_t i, atomic_t *v)
{
    *v += i;
}

extern __inline__ void atomic_sub(atomic_t i, atomic_t *v)
{
    *v -= i;
}

extern __inline__ void atomic_inc(atomic_t *v)
{
    *v += 1;
}

extern __inline__ void atomic_dec(atomic_t *v)
{
    *v -= 1;
}

extern __inline__ int atomic_dec_and_test(atomic_t *v)
{
    *v -= 1;
    return *v == 0;
}

#endif

